/**
 * This file was auto-generated by openapi-typescript.
 * Do not make direct changes to the file.
 */


export interface paths {
  "/api/boot": {
    /**
     * Retrieve all guild's configs
     * @description Returns all guild's configs.
     */
    get: operations["getGuildsForBoot"];
  };
  "/api/{guildId}/config": {
    /**
     * Find a guild's config by ID
     * @description Returns a single guild's config.
     */
    get: operations["getGuildById"];
    /**
     * Deletes a guild's config by ID
     * @description Delete a guild's config when the bot is removed from the guild.
     */
    delete: operations["deleteGuildById"];
  };
  "/api/{guildId}/tp_messages": {
    /**
     * Find the tp_messages of guild by ID
     * @description Returns tp_messages for a guild
     */
    get: operations["getTp_messagesOfGuildById"];
    /**
     * Put new message IDs for tp_messages of guild by ID
     * @description Returns tp_messages for a guild
     */
    put: operations["putTp_messagesOfGuildById"];
  };
  "/api/{guildId}/matches": {
    /**
     * Find all matches of guild by ID
     * @description Returns tp_messages for a guild
     */
    get: operations["getMatchesOfGuildById"];
    /**
     * Save a new created match of guild by ID
     * @description Returns tp_messages for a guild
     */
    post: operations["postMatchOfGuildById"];
  };
}

export type webhooks = Record<string, never>;

export interface components {
  schemas: {
    guildConfig: {
      /** @example 1234567890123456800 */
      guildId: number;
      /**
       * Format: text
       * @example Europe/Berlin
       */
      timezone: string;
      features: {
        timePlanning: {
          enabled: boolean;
          /** @example 1234567890123456800 */
          channelId: number | null;
          /** @example 0 */
          targetMinute: number;
          /** @example 1 */
          targetHour: number;
          /** @example 1 */
          targetDay: number;
          roles: {
            enabled: boolean;
            /** @example 1234567890123456800 */
            isAvailableRoleId: number | null;
            /** @example 1234567890123456800 */
            wantsToBeNotifieRoledId: number | null;
          };
        };
      };
      matches: components["schemas"]["match"][];
      checksum: string;
    };
    match: {
      /** @example 1234567890123456800 */
      channelId: number;
      /** @example 1234567890123456800 */
      createrId: number;
      /** @example 1234567890123456800 */
      roleId: number;
      /** @example 1234567890123456800 */
      messageId: number;
      /**
       * Format: varchar(50)
       * @example Scrim
       */
      matchType: string;
      /**
       * Format: varchar(100)
       * @example ?
       */
      opponentName: string;
      /** @example 2020-01-01T00:00:00Z */
      utc_ts: string;
    };
    tp_messages: {
      /** @example 1234567890123456800 */
      channelId: number;
      messageIds: {
        /** @example 1234567890123456800 */
        0: number | null;
        /** @example 1234567890123456800 */
        1: number | null;
        /** @example 1234567890123456800 */
        2: number | null;
        /** @example 1234567890123456800 */
        3: number | null;
        /** @example 1234567890123456800 */
        4: number | null;
        /** @example 1234567890123456800 */
        5: number | null;
        /** @example 1234567890123456800 */
        6: number | null;
      };
    };
  };
  responses: never;
  parameters: never;
  requestBodies: never;
  headers: never;
  pathItems: never;
}

export type $defs = Record<string, never>;

export type external = Record<string, never>;

export interface operations {

  /**
   * Retrieve all guild's configs
   * @description Returns all guild's configs.
   */
  getGuildsForBoot: {
    responses: {
      /** @description successful operation */
      200: {
        content: {
          "application/json": components["schemas"]["guildConfig"][];
        };
      };
      /** @description Invalid ID supplied */
      400: {
        content: never;
      };
      /** @description Unauthorized */
      401: {
        content: never;
      };
      /** @description Guild not found */
      404: {
        content: never;
      };
    };
  };
  /**
   * Find a guild's config by ID
   * @description Returns a single guild's config.
   */
  getGuildById: {
    parameters: {
      path: {
        /** @description ID of guild config to return */
        guildId: string;
      };
    };
    responses: {
      /** @description successful operation */
      200: {
        content: {
          "application/json": components["schemas"]["guildConfig"];
        };
      };
      /** @description Invalid ID supplied */
      400: {
        content: never;
      };
      /** @description Unauthorized */
      401: {
        content: never;
      };
      /** @description Guild not found */
      404: {
        content: never;
      };
    };
  };
  /**
   * Deletes a guild's config by ID
   * @description Delete a guild's config when the bot is removed from the guild.
   */
  deleteGuildById: {
    parameters: {
      path: {
        /** @description ID of guild config to delete */
        guildId: string;
      };
    };
    responses: {
      /** @description successful operation */
      204: {
        content: never;
      };
      /** @description Invalid ID supplied */
      400: {
        content: never;
      };
      /** @description Unauthorized */
      401: {
        content: never;
      };
      /** @description Guild not found */
      404: {
        content: never;
      };
    };
  };
  /**
   * Find the tp_messages of guild by ID
   * @description Returns tp_messages for a guild
   */
  getTp_messagesOfGuildById: {
    parameters: {
      path: {
        /** @description ID of guild's tp_messages to return */
        guildId: string;
      };
    };
    responses: {
      /** @description successful operation */
      200: {
        content: {
          "application/json": components["schemas"]["tp_messages"];
        };
      };
      /** @description Time planning not enabled for this guild */
      204: {
        content: never;
      };
      /** @description Invalid ID supplied */
      400: {
        content: never;
      };
      /** @description Unauthorized */
      401: {
        content: never;
      };
      /** @description Guild not found */
      404: {
        content: never;
      };
    };
  };
  /**
   * Put new message IDs for tp_messages of guild by ID
   * @description Returns tp_messages for a guild
   */
  putTp_messagesOfGuildById: {
    parameters: {
      path: {
        /** @description ID of guild's tp_messages to return */
        guildId: string;
      };
    };
    /** @description Put new message IDs for tp_messages in channel */
    requestBody: {
      content: {
        "application/json": components["schemas"]["tp_messages"];
      };
    };
    responses: {
      /** @description successful operation */
      204: {
        content: never;
      };
      /** @description Invalid ID supplied */
      400: {
        content: never;
      };
      /** @description Unauthorized */
      401: {
        content: never;
      };
      /** @description Time planning not enabled for this guild */
      403: {
        content: never;
      };
      /** @description Guild not found */
      404: {
        content: never;
      };
    };
  };
  /**
   * Find all matches of guild by ID
   * @description Returns tp_messages for a guild
   */
  getMatchesOfGuildById: {
    parameters: {
      path: {
        /** @description ID of guild's tp_messages to return */
        guildId: string;
      };
    };
    responses: {
      /** @description successful operation */
      200: {
        content: {
          "application/json": {
            matches: components["schemas"]["match"][];
            /**
             * Format: text
             * @example Europe/Berlin
             */
            timezone: string;
          };
        };
      };
      /** @description Time planning not enabled for this guild */
      204: {
        content: never;
      };
      /** @description Invalid ID supplied */
      400: {
        content: never;
      };
      /** @description Unauthorized */
      401: {
        content: never;
      };
      /** @description Guild not found */
      404: {
        content: never;
      };
    };
  };
  /**
   * Save a new created match of guild by ID
   * @description Returns tp_messages for a guild
   */
  postMatchOfGuildById: {
    parameters: {
      path: {
        /** @description ID of match's guild to set */
        guildId: string;
      };
    };
    /** @description Save a new created match in channel */
    requestBody: {
      content: {
        "application/json": {
          match: components["schemas"]["match"];
          /**
           * Format: text
           * @description Has to match guild tz
           * @example Europe/Berlin
           */
          timezone: string;
        };
      };
    };
    responses: {
      /** @description successful operation */
      204: {
        content: never;
      };
      /** @description Invalid ID supplied */
      400: {
        content: never;
      };
      /** @description Unauthorized */
      401: {
        content: never;
      };
      /** @description Guild not found */
      404: {
        content: never;
      };
    };
  };
}
